#!/usr/bin/env python



from gimpfu import *

def render_heart(size, heartcolor, bgcolor):

	
	
	#Create background layer
	SIZE = 500
	
	img = pdb.gimp_image_new(SIZE, SIZE, RGB)
	layer = pdb.gimp_layer_new(img, SIZE, SIZE, RGB, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_context_set_foreground ((000, 000, 000))
	pdb.gimp_drawable_fill(layer, FILL_FOREGROUND)
	
	#Create the first half of the heart
	
	#Create the first half layer
	layer = pdb.gimp_layer_new(img, SIZE, SIZE, RGB, "Heart", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_layer_add_alpha(layer)
	pdb.gimp_drawable_fill(layer, FILL_TRANSPARENT)
	
	#Create the half
	pdb.gimp_image_select_ellipse(img, 2, 60, 105, 385, 285)
	pdb.gimp_image_select_rectangle(img, 1, 0, 0, 500, 250)
	pdb.gimp_image_select_ellipse(img, 0, 60, 125, 385, 250)
	pdb.gimp_context_set_foreground ((191, 35, 57))
	pdb.gimp_drawable_edit_fill(layer, FILL_FOREGROUND)
	pdb.gimp_selection_none(img)
	drawable = pdb.gimp_drawable_transform_rotate(layer, 
													44.75, 
													TRUE, 
													250, 
													250, 
													0, 
													2, 
													TRUE, 
													1, 
													0)
	pdb.gimp_layer_resize_to_image_size(layer)
	pdb.gimp_image_select_rectangle(img, 2, 250, 0, 250, 500)
	non_empty = pdb.gimp_edit_cut(layer)
	pdb.gimp_selection_none(img)
	non_empty = pdb.gimp_edit_copy(layer)
	
	#Create the second half of the heart
	
	#Create the second by pasting into a new layer
	layer = pdb.gimp_layer_new(img, SIZE, SIZE, RGB, "Heart copy", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_layer_add_alpha(layer)
	pdb.gimp_drawable_fill(layer, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(layer, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	drawable = pdb.gimp_flip(layer, ORIENTATION_HORIZONTAL)
	layer = pdb.gimp_image_merge_down(img, layer, CLIP_TO_IMAGE)
	
	#Create and Inner shadow
		
	#Create inner shadow layer
	pdb.gimp_image_select_color(img, CHANNEL_OP_REPLACE, layer, (191, 35, 57))
	layer = pdb.gimp_layer_new(img, SIZE, SIZE, RGB, "Inner shadow", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_layer_add_alpha(layer)
	pdb.gimp_drawable_fill(layer, FILL_TRANSPARENT)
	
	pdb.gimp_selection_shrink(img, 8)
	pdb.gimp_context_set_brush("2. Hardness 100")
	pdb.gimp_context_set_brush_size(8)
	pdb.gimp_context_set_foreground ((0, 0, 0))
	pdb.gimp_edit_stroke(layer)
	pdb.gimp_selection_none(img)
	pdb.plug_in_gauss(img, layer, 48, 48, 1)
	layer = pdb.gimp_image_merge_down(img, layer, CLIP_TO_IMAGE)
	
	#Create the light reflection on the heart
			  
	#Create light reflection layer
	layer = pdb.gimp_layer_new(img, SIZE, SIZE, RGB, "Reflection", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_layer_add_alpha(layer)
	pdb.gimp_drawable_fill(layer, FILL_TRANSPARENT)
	
	#Draw the dot on the left side and apply gaussian blur
	pdb.gimp_context_set_brush ("2. Hardness 025")
	pdb.gimp_context_set_brush_size(85)
	pdb.gimp_context_set_foreground ((255, 255, 255))
	pdb.gimp_paintbrush_default(layer, 2, [170, 170])
	layer = pdb.gimp_image_merge_down(img, layer, CLIP_TO_IMAGE)
	
	gimp.Display(img)
	
	
	
	
	

register(
	"render_heart",
	"Creates a heart",
	"Creates a heart",
	"Pocholo",
	"Pocholo",
	"2020",
	"Heart",
	"",

[
	(PF_SPINNER, "Size", "Heart size", 500, (1, 1000, 1)),
	(PF_COLOR, "HeartColor", "Heart color", (191, 35, 57)),
	(PF_COLOR, "Bgcolor", "Background color", (000, 000, 000)),


],


 [],
render_heart, menu="<Image>/Python-Fu/Heart")

main()	
